Attribute VB_Name = "LangageGraphique"
' LangageGraphique, version 3.0
' Copyright (C) 2003-2011 Andr Boileau
' Macros cres par Andr Boileau (aot 2003) (dernire revision: novembre 2012)
' Rfrence: http://www.math.uqam.ca/_boileau/LangageGraphique.html

' Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
' selon les termes de la Licence Publique Gnrale GNU publie par
' la Free Software Foundation (version 2 ou bien toute autre version ultrieure choisie par vous).

' Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
' ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
' dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.


Public Const LG_TracerDansNouveauClasseur As Boolean = False
Public Const LG_MiseAuPoint As Boolean = False
Public Const pi As Double = 3.1415926535898

Public LG_FeuilleInitiale
Public LG_TortueX As Double, LG_TortueY As Double, LG_TortueAngle As Double, LG_TortueCrayon As Boolean
Public LG_CentreX As Double, LG_CentreY As Double
Public LG_TortueR As Integer, LG_TortueG As Integer, LG_TortueB As Integer, LG_TortueEpais As Integer
Public LG_TortueRemplis As Boolean, LG_RemplissageR As Integer, LG_RemplissageG As Integer, LG_RemplissageB As Integer
Public LG_Points(10000, 1) As Double, LG_NbPoints As Integer
Public LG_ProFacteur As Double

Public LG_FonctionsXmin As Double, LG_FonctionsXmax As Double, LG_FonctionsYmin As Double, LG_FonctionsYmax As Double
Public LG_FenetreXmin As Double, LG_FenetreXmax As Double, LG_FenetreYmin As Double, LG_FenetreYmax As Double
Public LG_FonctionsMX As Double, LG_FonctionsBX As Double, LG_FonctionsMY As Double, LG_FonctionsBY As Double
Public LG_FonctionsMXE As Double, LG_FonctionsBXE As Double, LG_FonctionsMYE As Double, LG_FonctionsBYE As Double
Public FonctionsPas As Double, FonctionsPointsRelies As Boolean

Public LG_NbTotalImagesFilm As Integer
Public LG_NomFenetre, LG_NomFenetreFilm, LG_CheminVersFichiersImages As String
Public LG_ModeDemo, LG_AnimationMac As Boolean

Public LG_MachineCourante, LG_chaineAdaptee As String
Public LG_BugArc As Boolean

Sub Init()
    Dim VersionVBA As Integer
    LG_CentreX = 305
    LG_CentreY = 390
    LG_TortueX = 0
    LG_TortueY = 0
    LG_TortueAngle = 0
    LG_TortueCrayon = True
    LG_TortueR = 0
    LG_TortueG = 0
    LG_TortueB = 0
    LG_TortueEpais = 1
    LG_TortueRemplis = False
    LG_RemplissageR = 0
    LG_RemplissageG = 0
    LG_RemplissageB = 0
    LG_NbPoints = 0
    LG_ProFacteur = 0.5
    LG_MachineCourante = Mid(Application.OperatingSystem, 1, 3)
    VersionVBA = CDbl(Mid(Application.Version, 1, 2))
    LG_AnimationMac = (LG_MachineCourante = "Mac") And (VersionVBA < 14)
    LG_BugArc = VersionVBA >= 14
End Sub

Sub EffacerTableau()
    Selection.WholeStory
    Selection.TypeBackspace
End Sub

Sub VE()
    Init
    Set monDocument = ActiveSheet 'Worksheets(1)
    For i = monDocument.Shapes.Count To 1 Step -1
        If FormeP(monDocument.Shapes.Item(i).Type) And (monDocument.Shapes.Item(i).OnAction = "") Then
            monDocument.Shapes.Item(i).Delete
        End If
     Next
End Sub

Function FormeP(no)
    FormeP = True ' les shapes ont plusieurs numros, dont 1 et 9
    If no = 8 Then FormeP = False ' 8 est le numro/type des contrles
    If no = 13 Then FormeP = False ' 13 est le numro/type des images
    If no = 7 Then FormeP = False ' 7 est le numro/type des quations
    'If no = 17 Then FormeP = False ' 17 est le numro/type des zones de texte
End Function

Sub ViderEcran()
    VE
End Sub

Sub Segment(x1, y1, x2, y2)   ' Accepte les nombres dcimaux
    If LG_TortueRemplis Then
        If LG_NbPoints = 0 Then
            LG_Points(0, 0) = x1 + LG_CentreX
            LG_Points(0, 1) = LG_CentreY - y1
            LG_NbPoints = 1
        End If
        LG_Points(LG_NbPoints, 0) = x2 + LG_CentreX
        LG_Points(LG_NbPoints, 1) = LG_CentreY - y2
        LG_NbPoints = LG_NbPoints + 1
        If LG_MiseAuPoint Then
            ActiveSheet.Shapes.AddLine(x1 + LG_CentreX, LG_CentreY - y1, x2 + LG_CentreX, LG_CentreY - y2).Select
            Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
            Selection.ShapeRange.Line.Weight = LG_TortueEpais
        End If
    Else
        ActiveSheet.Shapes.AddLine(x1 + LG_CentreX, LG_CentreY - y1, x2 + LG_CentreX, LG_CentreY - y2).Select
        Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
        Selection.ShapeRange.Line.Weight = LG_TortueEpais
    End If
End Sub

Sub Poly()
    Dim i As Integer
    On Error GoTo Erreur
    If LG_NbPoints < 2 Then Exit Sub
    With ActiveSheet.Shapes.BuildFreeform(msoEditingAuto, LG_Points(0, 0), LG_Points(0, 1))
        For i = 1 To LG_NbPoints - 1
            .AddNodes msoSegmentLine, msoEditingAuto, LG_Points(i, 0), LG_Points(i, 1)
        Next i
        .ConvertToShape.Select
    End With
    Selection.ShapeRange.Line.Visible = LG_TortueCrayon  ' msoTrue ou msoFalse
    Selection.ShapeRange.Line.Weight = LG_TortueEpais
    Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
    If LG_TortueRemplis Then
        Selection.ShapeRange.Fill.ForeColor.RGB = RGB(LG_RemplissageR, LG_RemplissageG, LG_RemplissageB)
        Selection.ShapeRange.Fill.Solid ' Si on veut interdire les dgrads
    End If
    Selection.ShapeRange.Shadow.Visible = msoFalse ' Si on veut interdire les ombres
    Exit Sub
Erreur:     LG_TortueRemplis = False
            PolyDegenere
End Sub

Sub PolyDegenere()
    Dim i As Integer
    If LG_NbPoints < 2 Then Exit Sub
    For i = 0 To LG_NbPoints - 2
        ActiveSheet.Shapes.AddLine(LG_Points(i, 0), LG_Points(i, 1), LG_Points(i + 1, 0), LG_Points(i + 1, 1)).Select
        Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
        Selection.ShapeRange.Line.Weight = LG_TortueEpais
    Next i
End Sub

Sub Ellipse(x1, y1, x2, y2, Remplir, Angle)
    ActiveSheet.Shapes.AddShape(msoShapeOval, x1 + LG_CentreX, LG_CentreY - y2, x2 - x1, y2 - y1).Select
    Selection.ShapeRange.Line.Weight = LG_TortueEpais
    Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
    Selection.ShapeRange.IncrementRotation (Angle Mod 360)
    If Remplir Then
        Selection.ShapeRange.Fill.ForeColor.RGB = RGB(LG_RemplissageR, LG_RemplissageG, LG_RemplissageB)
        Selection.ShapeRange.Fill.Visible = msoTrue
        Selection.ShapeRange.Fill.Solid
    Else
        Selection.ShapeRange.Fill.Visible = msoFalse
    End If
End Sub

Sub Cercle(x, y, r)
    Ellipse x - r, y - r, x + r, y + r, False, 0
End Sub

Sub Disque(x, y, r)
    Ellipse x - r, y - r, x + r, y + r, True, 0
End Sub

Sub Arc(x, y, r, ByVal depart, ByVal arrivee)
    If depart = arrivee Then Exit Sub
    If LG_BugArc Then depart = -depart: arrivee = -arrivee
    ActiveSheet.Shapes.AddShape(msoShapeArc, x + LG_CentreX, LG_CentreY - r - y, r, r).Select
    Selection.ShapeRange.Adjustments.Item(1) = arrivee
    Selection.ShapeRange.Adjustments.Item(2) = depart
    Selection.ShapeRange.Line.Weight = LG_TortueEpais
    Selection.ShapeRange.Line.ForeColor.RGB = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
End Sub

Sub Av(d)
    Dim x As Double, y As Double
    x = LG_TortueX + d * Sin(LG_TortueAngle * pi / 180)
    y = LG_TortueY + d * Cos(LG_TortueAngle * pi / 180)
    If LG_TortueCrayon Or LG_TortueRemplis Then Segment LG_TortueX, LG_TortueY, x, y
    LG_TortueX = x
    LG_TortueY = y
End Sub

Sub Avance(d)
    Av d
End Sub

Sub Fd(d)
    Av d
End Sub

Sub Dr(a)
    LG_TortueAngle = LG_TortueAngle + a
    If LG_TortueAngle > 360 Then LG_TortueAngle = LG_TortueAngle - 360
    If LG_TortueAngle < -360 Then LG_TortueAngle = LG_TortueAngle + 360
End Sub

Sub Droite(a)
    Dr a
End Sub

Sub Rt(a)
    Dr a
End Sub

Sub FPos(x, y)
    If LG_TortueCrayon Or LG_TortueRemplis Then Segment LG_TortueX, LG_TortueY, x, y
    LG_TortueX = x
    LG_TortueY = y
End Sub

Sub FixePosition(x, y)
    FPos x, y
End Sub

Function PosX()
    PosX = LG_TortueX
End Function

Function PosY()
    PosY = LG_TortueY
End Function

Sub FCap(a)
    LG_TortueAngle = a
End Sub

Sub FixeCap(a)
    FCap a
End Sub

Function Cap()
    Cap = LG_TortueAngle
End Function

Function CapVers(x, y)
    x = x - LG_TortueX
    y = y - LG_TortueY
    If x = 0 Then
        CapVers = Sgn(y) * 90 - 90
    Else
        CapVers = 90 * Sgn(x) - Atn(y / x) * 180 / pi
    End If
End Function

Sub LC()
    LG_TortueCrayon = False
End Sub

Sub LeveCrayon()
    LC
End Sub

Sub BC()
    LG_TortueCrayon = True
End Sub

Sub BaisseCrayon()
    BC
End Sub

Sub CC(r, G, b)
    LG_TortueR = r
    LG_TortueG = G
    LG_TortueB = b
End Sub

Sub CouleurCrayon(r, G, b)
    CC r, G, b
End Sub

Sub TC(d)
    LG_TortueEpais = d
End Sub

Sub TailleCrayon(d)
    TC d
End Sub

Sub DebutRemplir()
    If LG_TortueRemplis Then Exit Sub
    LG_TortueRemplis = True
    LG_NbPoints = 0
End Sub

Sub FinRemplir()
    Poly
    LG_TortueRemplis = False
End Sub

Sub CR(r, G, b)
    LG_RemplissageR = r
    LG_RemplissageG = G
    LG_RemplissageB = b
End Sub

Sub CouleurRemplissage(r, G, b)
    CR r, G, b
End Sub

Sub Dessous()
    Selection.ShapeRange.ZOrder msoSendToBack
End Sub

Sub Dessus()
    Selection.ShapeRange.ZOrder msoBringToFront
End Sub

Sub Texte(chaine, x, y, Police, taille, Gras, Italique)
    x = LG_CentreX + x
    y = LG_CentreY - y
    ActiveSheet.Shapes.AddTextbox(msoTextOrientationHorizontal, x, y, 200, 200).Select
    Selection.Font.Color = RGB(LG_TortueR, LG_TortueG, LG_TortueB)
    Selection.Font.Name = Police ' "Chicago"
    Selection.Font.Size = taille
    Selection.Font.Bold = Gras
    Selection.Font.Italic = Italique
    ' Selection.TypeText Text:=chaine
    Selection.Characters.Text = chaine
    Selection.ShapeRange.Line.Visible = msoFalse
    Selection.ShapeRange.Fill.Visible = msoFalse
End Sub

Sub Etiquette()
    ActiveSheet.Shapes.AddTextbox(msoTextOrientationHorizontal, 330, 110, 20, 20).Select
    Selection.Characters.Text = "?" 'dans Word: Selection.TypeText Text:="?"
    Selection.ShapeRange.Line.Visible = msoFalse
    Selection.ShapeRange.Fill.Visible = msoFalse
'    With Selection.Characters(Start:=1, Length:=1).Font
'        .Name = "Verdana"
'        .FontStyle = "Normal"
'        .Size = 10
'        .Strikethrough = False
'        .Superscript = False
'        .Subscript = False
'        .OutlineFont = False
'        .Shadow = False
'        .Underline = xlUnderlineStyleNone
'        .ColorIndex = xlAutomatic
'    End With
End Sub

Sub RectangleGen(x1, y1, x2, y2, Remplir)
    If Remplir Then DebutRemplir
    Segment x1, y1, x2, y1
    Segment x2, y1, x2, y2
    Segment x2, y2, x1, y2
    Segment x1, y2, x1, y1
    If Remplir Then FinRemplir
End Sub

Sub Rectangle(x1, y1, x2, y2)
    RectangleGen x1, y1, x2, y2, False
End Sub

Sub RectanglePlein(x1, y1, x2, y2)
    RectangleGen x1, y1, x2, y2, True
End Sub

Function Hasard(a, b)
    Hasard = a + (b + 1 - a) * Rnd()
End Function

Function CosD(x)
    CosD = Cos(x * pi / 180)
End Function

Function SinD(x)
    SinD = Sin(x * pi / 180)
End Function

Function TanD(x)
    TanD = Tan(x * pi / 180)
End Function

Function pixelsAcm(x)
    pixelsAcm = 0.03527777777 * x
End Function

Function cmApixels(x)
    cmApixels = x / 0.03527777777
End Function

Function unitesAcm(x)
    unitesAcm = 0.03527777777 * x
End Function

Function cmAunites(x)
    cmAunites = x / 0.03527777777
End Function

Sub Grille(x, y, dx, dy, nx, ny)
    Dim i As Integer
    For i = 0 To nx
        Segment x + i * dx, y, x + i * dx, y + ny * dy
    Next i
    For i = 0 To ny
        Segment x, y + i * dy, x + nx * dx, y + i * dy
    Next i
End Sub

Sub ProPoint(x, y, r, G, b, E)
    CC r / 256, G / 256, b / 256
    CR r / 256, G / 256, b / 256
    TC 1
    Disque LG_ProFacteur * x, -LG_ProFacteur * y, LG_ProFacteur * E / 2
End Sub

Sub ProSegment(x1, y1, x2, y2, r, G, b, E)
    CC r / 256, G / 256, b / 256
    TC LG_ProFacteur * E
    Segment LG_ProFacteur * x1, -LG_ProFacteur * y1, LG_ProFacteur * x2, -LG_ProFacteur * y2
End Sub

Sub ProCercle(x, y, rayon, r, G, b, E)
    CC r / 256, G / 256, b / 256
    TC LG_ProFacteur * E
    Cercle LG_ProFacteur * x, -LG_ProFacteur * y, LG_ProFacteur * rayon
End Sub

Sub ProArc(x, y, rayon, debut, Fin, r, G, b, E)
    CC r / 256, G / 256, b / 256
    TC LG_ProFacteur * E
    Arc LG_ProFacteur * x, -LG_ProFacteur * y, LG_ProFacteur * rayon, 360 - Fin, 360 - debut
End Sub

Sub ProClip(xmin, xmax, ymin, ymax)
    CR 255, 255, 200
    RectangleGen LG_ProFacteur * xmin, -LG_ProFacteur * ymin, LG_ProFacteur * xmax, -LG_ProFacteur * ymax, True
End Sub

Sub InitFonctions()
    FonctionsPas = 1
    FonctionsPointsRelies = True
    LG_FonctionsXmin = -10
    LG_FonctionsXmax = 10
    LG_FonctionsYmin = -10
    LG_FonctionsYmax = 10
    FenetreFonctions -50, 50, -25, 25
End Sub

Sub RegionFonctions(xmin, xmax, ymin, ymax)
    LG_FonctionsXmin = xmin
    LG_FonctionsXmax = xmax
    LG_FonctionsYmin = ymin
    LG_FonctionsYmax = ymax
    CalculCoefficientsFonctions
End Sub

Sub FenetreFonctions(gauche_, droite_, bas_, haut_)
    LG_FenetreXmin = gauche_
    LG_FenetreXmax = droite_
    LG_FenetreYmin = bas_
    LG_FenetreYmax = haut_
    CalculCoefficientsFonctions
End Sub

Sub DimGraphesFonctions(Base, Hauteur)
    FenetreFonctions -Base / 2, Base / 2, -Hauteur / 2, Hauteur / 2
End Sub

Sub GrilleFonctions(nx, ny)
    Dim i As Integer, d As Double
    If (nx < 1) Or (ny < 1) Then Exit Sub
    d = (LG_FenetreXmax - LG_FenetreXmin) / nx
    For i = 0 To nx
        Segment LG_FenetreXmin + i * d, LG_FenetreYmin, LG_FenetreXmin + i * d, LG_FenetreYmax
    Next i
    d = (LG_FenetreYmax - LG_FenetreYmin) / ny
    For i = 0 To ny
        Segment LG_FenetreXmin, LG_FenetreYmin + i * d, LG_FenetreXmax, LG_FenetreYmin + i * d
    Next i
End Sub

Sub CalculCoefficientsFonctions()
'x = LG_FonctionsMX * xE + LG_FonctionsBX  ;  y = LG_FonctionsMY * xE + LG_FonctionsBY  ;  xE = LG_FonctionsMXE * x + LG_FonctionsBXE  ;  yE = LG_FonctionsMYE * x + LG_FonctionsBYE
    LG_FonctionsMX = (LG_FonctionsXmax - LG_FonctionsXmin) / (LG_FenetreXmax - LG_FenetreXmin)
    LG_FonctionsBX = LG_FonctionsXmin - LG_FenetreXmin * LG_FonctionsMX
    LG_FonctionsMXE = 1 / LG_FonctionsMX
    LG_FonctionsBXE = LG_FenetreXmin - LG_FonctionsXmin * LG_FonctionsMXE
    LG_FonctionsMYE = (LG_FenetreYmax - LG_FenetreYmin) / (LG_FonctionsYmax - LG_FonctionsYmin)
    LG_FonctionsBYE = LG_FenetreYmin - LG_FonctionsYmin * LG_FonctionsMYE
    LG_FonctionsMY = 1 / LG_FonctionsMYE
    LG_FonctionsBY = LG_FonctionsYmin - LG_FenetreYmin * LG_FonctionsMY
End Sub

Sub TracerAxes()
    yE = ConvYE(0)
    If LG_FenetreYmin <= yE And yE <= LG_FenetreYmax Then
        Segment LG_FenetreXmin, yE, LG_FenetreXmax, yE
        Selection.ShapeRange.Line.BeginArrowheadStyle = msoArrowheadNone
        Selection.ShapeRange.Line.EndArrowheadStyle = msoArrowheadTriangle
        Selection.ShapeRange.Line.EndArrowheadWidth = msoArrowheadWidthMedium
        Selection.ShapeRange.Line.EndArrowheadLength = msoArrowheadLengthMedium
        Selection.ShapeRange.Line.Visible = msoTrue
        xE = ConvXE(0)
    End If
    If LG_FenetreXmin <= xE And xE <= LG_FenetreXmax Then
        Segment xE, LG_FenetreYmin, xE, LG_FenetreYmax
        Selection.ShapeRange.Line.BeginArrowheadStyle = msoArrowheadNone
        Selection.ShapeRange.Line.EndArrowheadStyle = msoArrowheadTriangle
        Selection.ShapeRange.Line.EndArrowheadWidth = msoArrowheadWidthMedium
        Selection.ShapeRange.Line.EndArrowheadLength = msoArrowheadLengthMedium
    End If
End Sub

Function ConvXE(x)
    ConvXE = LG_FonctionsMXE * x + LG_FonctionsBXE
End Function

Function ConvYE(y)
    ConvYE = LG_FonctionsMYE * y + LG_FonctionsBYE
End Function

Sub PasFonctions(a)
    FonctionsPas = a
End Sub

Sub PointsRelies()
    FonctionsPointsRelies = True
End Sub

Sub PointsNonRelies()
    FonctionsPointsRelies = False
End Sub

Sub TracerFonctionAux(NumeroFonction, Pas, Lier)
    Dim yE0 As Variant, xE As Double, x As Double, y As Variant, yE As Double
    yE0 = "ND"
    For xE = LG_FenetreXmin To LG_FenetreXmax Step Pas
        x = LG_FonctionsMX * xE + LG_FonctionsBX
        y = F(NumeroFonction, x)
        If y = "ND" Then  ' ND = Non Dfini
            yE0 = "ND"
        Else
            If Not Lier Then
                If (LG_FonctionsYmin <= y) And (y <= LG_FonctionsYmax) Then
                    yE = LG_FonctionsMYE * y + LG_FonctionsBYE
                    Disque xE, yE, LG_TortueEpais / 2
                End If
            Else
                If y < LG_FonctionsYmin Then y = LG_FonctionsYmin
                If y > LG_FonctionsYmax Then y = LG_FonctionsYmax
                yE = LG_FonctionsMYE * y + LG_FonctionsBYE
                Select Case yE0
                    Case "ND"
                        Segment xE, yE, xE, yE
                    Case Else
                        Segment xE - Pas, yE0, xE, yE
                End Select
            End If
            yE0 = yE
        End If
    Next xE
    CadreFonctions
End Sub

Sub TracerFonction(NumeroFonction)
    If LG_ModeDemo Then
        TracerFonctionAuxDemo NumeroFonction, FonctionsPas, FonctionsPointsRelies
    Else
        TracerFonctionAux NumeroFonction, FonctionsPas, FonctionsPointsRelies
    End If
End Sub

Sub CadreFonctions()
    Dim r As Integer, G As Integer, b As Integer, E As Integer
    r = LG_TortueR
    G = LG_TortueG
    b = LG_TortueB
    E = LG_TortueEpais
    LG_TortueR = 0
    LG_TortueG = 0
    LG_TortueB = 0
    ' LG_TortueEpais = 1
    Rectangle LG_FenetreXmin, LG_FenetreYmax, LG_FenetreXmax, LG_FenetreYmin
    LG_TortueR = r
    LG_TortueG = G
    LG_TortueB = b
    LG_TortueEpais = E
End Sub

Sub TracerFparam(no, debut, Fin, nombrePoints)
    Dim x0 As Variant, y0 As Variant, x As Variant, y As Variant
    Dim k As Integer, dt As Double
    dt = (Fin - debut) / nombrePoints
    For k = 0 To nombrePoints
        t = debut + k * dt
        Fparam no, t, x, y
        If y = "ND" Then x = "ND"
        If x <> "ND" Then
            If k = 0 Then
                If Not FonctionsPointsRelies Then Point x, y
            Else
                If Not FonctionsPointsRelies Then Point x, y
                If FonctionsPointsRelies And x0 <> "ND" Then _
                SegmentClip LG_FonctionsMXE * x0 + LG_FonctionsBXE, _
                                LG_FonctionsMYE * y0 + LG_FonctionsBYE, _
                                LG_FonctionsMXE * x + LG_FonctionsBXE, _
                                LG_FonctionsMYE * y + LG_FonctionsBYE, _
                                LG_FenetreXmin, LG_FenetreXmax, LG_FenetreYmin, LG_FenetreYmax
            End If
        End If
        x0 = x
        y0 = y
    Next k
End Sub

Sub Point(x, y)
    Dim xE As Double, yE As Double
    If x < LG_FonctionsXmin Or LG_FonctionsXmax < x Then Exit Sub
    If y < LG_FonctionsYmin Or LG_FonctionsYmax < y Then Exit Sub
    xE = LG_FonctionsMXE * x + LG_FonctionsBXE
    yE = LG_FonctionsMYE * y + LG_FonctionsBYE
    Disque xE, yE, LG_TortueEpais / 2
End Sub

Sub SegmentClip(x, y, u, v, a, b, c, d)
    Dim p(2, 2) As Double, np As Integer, t As Double, w As Double
    np = 0
    If a <= x And x <= b And c <= y And y <= d Then
        np = np + 1
        p(np, 1) = x
        p(np, 2) = y
    End If
    If a <= u And u <= b And c <= v And v <= d Then
        np = np + 1
        p(np, 1) = u
        p(np, 2) = v
        If np = 2 Then Segment p(1, 1), p(1, 2), p(2, 1), p(2, 2): Exit Sub
    End If
    If x <> u Then
        t = (a - x) / (u - x): w = y + t * (v - y)
        If 0 < t And t < 1 And c <= w And w <= d Then
            np = np + 1
            p(np, 1) = x + t * (u - x)
            p(np, 2) = w
            If np = 2 Then Segment p(1, 1), p(1, 2), p(2, 1), p(2, 2): Exit Sub
        End If
        t = (b - x) / (u - x): w = y + t * (v - y)
        If 0 < t And t < 1 And c <= w And w <= d Then
            np = np + 1
            p(np, 1) = x + t * (u - x)
            p(np, 2) = w
            If np = 2 Then Segment p(1, 1), p(1, 2), p(2, 1), p(2, 2): Exit Sub
        End If
    End If
    If y <> v Then
        t = (c - y) / (v - y): w = x + t * (u - x)
        If 0 < t And t < 1 And a <= w And w <= b Then
            np = np + 1
            p(np, 1) = w
            p(np, 2) = y + t * (v - y)
            If np = 2 Then Segment p(1, 1), p(1, 2), p(2, 1), p(2, 2): Exit Sub
        End If
        t = (d - y) / (v - y): w = x + t * (u - x)
        If 0 < t And t < 1 And a <= w And w <= b Then
            np = np + 1
            p(np, 1) = w
            p(np, 2) = y + t * (v - y)
            If np = 2 Then Segment p(1, 1), p(1, 2), p(2, 1), p(2, 2): Exit Sub
        End If
    End If
End Sub

Sub TracerFonctionIntervalle(NumeroFonction, abscisseMin, abscisseMax)
    Dim yE0 As Variant, xE As Double, x As Double, y As Variant, yE As Double
    yE0 = "ND"
    Pas = FonctionsPas
    Lier = FonctionsPointsRelies
    intervallexmin = Round((abscisseMin - LG_FonctionsBX) / LG_FonctionsMX)
    intervallexmin = max(LG_FenetreXmin, min(LG_FenetreXmax, intervallexmin))
    intervallexmax = Round((abscisseMax - LG_FonctionsBX) / LG_FonctionsMX)
    intervallexmax = max(LG_FenetreXmin, min(LG_FenetreXmax, intervallexmax))
    For xE = intervallexmin To intervallexmax Step Pas
        x = LG_FonctionsMX * xE + LG_FonctionsBX
        y = F(NumeroFonction, x)
        If y = "ND" Then  ' ND = Non Dfini
            yE0 = "ND"
        Else
            If Not Lier Then
                If (LG_FonctionsYmin <= y) And (y <= LG_FonctionsYmax) Then
                    yE = LG_FonctionsMYE * y + LG_FonctionsBYE
                    Disque xE, yE, LG_TortueEpais / 2
                End If
            Else
                If y < LG_FonctionsYmin Then y = LG_FonctionsYmin
                If y > LG_FonctionsYmax Then y = LG_FonctionsYmax
                yE = LG_FonctionsMYE * y + LG_FonctionsBYE
                Select Case yE0
                    Case "ND"
                        Segment xE, yE, xE, yE
                    Case Else
                        Segment xE - Pas, yE0, xE, yE
                End Select
            End If
            yE0 = yE
        End If
    Next xE
    CadreFonctions
End Sub

Function min(x, y)
    If x < y Then min = x Else min = y
End Function

Function max(x, y)
    If x > y Then max = x Else max = y
End Function

Function Round(x)
    Round = Int(x + 0.5)
End Function

Sub FaireFilm(nb, x0, y0, x1, y1, r, v, b)
    CreerNouvelleFeuilleSiNecessaire
    If Not LG_AnimationMac Then
        DemanderChemin
        If LG_CheminVersFichiersImages = "" Then Exit Sub
    End If
    LG_NbTotalImagesFilm = nb
    InitFilm
    If r = 255 And v = 255 And b = 255 Then r = 254
    For noImage = 1 To LG_NbTotalImagesFilm
        CR r, v, b
        RectanglePlein x0, y0, x1, y1
        If LG_ModeDemo Then
            TracerImageDemo noImage
        Else
            TracerImage noImage
        End If
        If LG_AnimationMac Then AjouterImageAuFilm Else EnregistrerImage noImage
    Next noImage
    VE
    Sheets(1).Select
    Application.ScreenUpdating = True
    If LG_MachineCourante = "Mac" Then LG_chaineAdaptee = "Termin!" Else LG_chaineAdaptee = "Termin!"
    If LG_AnimationMac Then ToutSelectionner: DonnerInfoAnimationMac Else MsgBox LG_chaineAdaptee
End Sub

Sub FaireFilmPlus(nb, x0, y0, x1, y1, r, v, b)
    CreerNouvelleFeuilleSiNecessaire
    If Not LG_AnimationMac Then
        DemanderChemin
        If LG_CheminVersFichiersImages = "" Then Exit Sub
    End If
    LG_NbTotalImagesFilm = nb
    InitFilm
    If r = 255 And v = 255 And b = 255 Then r = 254
    For noImage = 1 To LG_NbTotalImagesFilm
        CR r, v, b
        RectanglePlein x0, y0, x1, y1
        TracerImagePlus noImage, LG_NbTotalImagesFilm
        If LG_AnimationMac Then AjouterImageAuFilm Else EnregistrerImage noImage
    Next noImage
    VE
    Sheets(1).Select
    Application.ScreenUpdating = True
    If LG_AnimationMac Then ToutSelectionner: DonnerInfoAnimationMac
End Sub

Sub InitFilm()
    Sheets(1).Select
    Range("A1").Select
    If LG_AnimationMac Then Sheets(2).Select
    VE
End Sub

Sub AjouterImageAuFilm()
    GrouperGraphique
    Selection.Cut
    Sheets(1).Select
    ActiveSheet.Paste
    Dessous
    Range("A1").Select
    If LG_AnimationMac Then Sheets(2).Select
End Sub

Sub EnregistrerImage(numero)   ' Pourrait-on spcifier au pralable un dossier/rpertoire o placer ces fichiers ???
    Dim GraphTemp, ImageCourante, NomFichier, TypeFichier, NomFeuille As String
    Dim Base As Long, Hauteur As Long
    If LG_AnimationMac Then NomFeuille = Sheets(2).Name Else NomFeuille = Sheets(1).Name
    GrouperGraphique
    TypeFichier = "PNG"         '"JPEG"
    NomFichier = CStr(numero)
    While Len(NomFichier) < 3
        NomFichier = "0" & NomFichier
    Wend
    NomFichier = LG_CheminVersFichiersImages & "Image_" & NomFichier & "." & TypeFichier
    Hauteur = Selection.ShapeRange.Height
    Base = Selection.ShapeRange.Width
    Selection.Cut
    Charts.Add
    ActiveChart.Location Where:=xlLocationAsObject, Name:=NomFeuille   '  "Feuil3" ' ********
    Selection.Border.LineStyle = 0
    GraphTemp = ActiveSheet.Shapes.Count
    ActiveSheet.Shapes(GraphTemp).Width = Base
    ActiveSheet.Shapes(GraphTemp).Height = Hauteur
    ActiveChart.ChartArea.Select
    ActiveChart.Paste
    ActiveSheet.ChartObjects(1).Chart.Export NomFichier, TypeFichier, True
       ' L'instruction de la ligne prcdente fonctionne dans Excel 2010 (Win) et 2011 (Mac) mais pas dans Excel 2004 (Mac)
    ActiveSheet.Shapes(GraphTemp).Cut
End Sub

Sub EXDemanderChemin()
    Dim pos, posPoint As Integer
    LG_CheminVersFichiersImages = Application.GetSaveAsFilename(InitialFileName:="Nom du dossier", Title:="Nom du dossier")
    If LG_CheminVersFichiersImages = "False" Then
        LG_CheminVersFichiersImages = ""
    Else
        pos = Len(LG_CheminVersFichiersImages)
        While Mid(LG_CheminVersFichiersImages, pos, 1) <> Application.PathSeparator
            pos = pos - 1
        Wend
        'LG_CheminVersFichiersImages = Mid(LG_CheminVersFichiersImages, 1, pos)
    End If
    posPoint = pos + 1
    For k = pos + 1 To Len(LG_CheminVersFichiersImages)
        If Mid(LG_CheminVersFichiersImages, k, 1) = "." Then posPoint = k: Exit For
    Next k
    LG_CheminVersFichiersImages = Mid(LG_CheminVersFichiersImages, 1, posPoint - 1)
    On Error GoTo ErreurDossier
    MkDir LG_CheminVersFichiersImages
    LG_CheminVersFichiersImages = LG_CheminVersFichiersImages & Application.PathSeparator
    Exit Sub
ErreurDossier:
    If LG_MachineCourante = "Mac" Then LG_chaineAdaptee = "Erreur lors de la cration du dossier" Else LG_chaineAdaptee = "Erreur lors de la cration du dossier"
    MsgBox LG_chaineAdaptee
    LG_CheminVersFichiersImages = ""
End Sub

Sub DemanderChemin()
    If Mid(Application.OperatingSystem, 1, 3) = "Mac" Then
        LG_CheminVersFichiersImages = CheminDossierMac()
    Else
        LG_CheminVersFichiersImages = CheminDossierWin()
    End If
End Sub

Function CheminDossierMac()
    CheminDossierMac = ""
    On Error Resume Next
        CheminDossierMac = MacScript("choose folder as string")
    On Error GoTo 0
End Function

Function CheminDossierWin(Optional CheminInitial As String) As String
    Dim numero As Long
    CheminDossierWin = vbNullString
    With Application.FileDialog(msoFileDialogFolderPicker)
        .InitialFileName = CheminInitial
        .Show
        For numero = 1 To .SelectedItems.Count
            CheminDossierWin = .SelectedItems(numero) & "\"
        Next numero
    End With
End Function

Sub DonnerInfoAnimationMac()
        MsgBox "Pour raliser une animation" _
                    + Chr(13) + "1) Enregistrer en tant qu'image, en cochant l'option " _
                    + Chr(13) + "    'chaque graphique dans un fichier distinct'." _
                    + Chr(13) + "2) Ouvrir une squence d'images avec QuickTime Player."
End Sub

Function DemanderEntier(message, valeurInit)
    DemanderEntier = valeurInit
    recommencer = True
    While recommencer
        reponse = CStr(InputBox(message, "Demande d'un entier", valeurInit))
        If reponse = "" Then
            Exit Function
        End If
        If Not IsNumeric(reponse) Then
        Else
            On Error GoTo saut
            If CInt(reponse) = CDbl(reponse) Then
                reponse = CInt(reponse)
                recommencer = False
            End If
saut:    On Error GoTo 0
        End If
    Wend
    DemanderEntier = reponse
End Function

Function DemanderDecimal(message, valeurInit)
    DemanderDecimal = valeurInit
    recommencer = True
    While recommencer
        reponse = CStr(InputBox(message, "Demande d'un decimal", valeurInit))
        If reponse = "" Then
            Exit Function
        End If
        If Not IsNumeric(reponse) Then
        Else
            On Error GoTo saut
            reponse = CDbl(reponse)
            recommencer = False
saut:    On Error GoTo 0
        End If
    Wend
    DemanderDecimal = reponse
End Function

Function DemanderChaine(message, valeurInit)
    reponse = CStr(InputBox(message, "Demande d'une chaine", valeurInit))
    If reponse = "" Then
        DemanderChaine = valeurInit
    Else
        DemanderChaine = reponse
    End If
End Function

Sub GrouperGraphique()
     ToutSelectionner
     On Error Resume Next
     Selection.ShapeRange.Group.Select
     Selection.ShapeRange.ZOrder msoSendToBack
     On Error GoTo 0
End Sub

Sub ToutSelectionner()
    Set monDocument = ActiveSheet ' Worksheets(1)
    For i = monDocument.Shapes.Count To 1 Step -1
        If FormeP(monDocument.Shapes.Item(i).Type) And (monDocument.Shapes.Item(i).OnAction = "") Then
            monDocument.Shapes.Item(i).Select False ' false pour ne pas dslectionner ce qui est dj slectionn
        End If
     Next
End Sub

Sub CreeerNouveauClasseur()
    Workbooks.Add
    Sheets.Add
    Sheets(1).Select
    Windows(1).Activate
End Sub

Sub CreerNouvelleFeuilleSiNecessaire()
    If Worksheets.Count = 1 And LG_AnimationMac Then Sheets.Add After:=Worksheets(Worksheets.Count)
    Sheets(1).Select
End Sub

Function cellule(ligne, colonne) ' Utiliser suffix avec ".Value" ou ".FormulaR1C1" ou ".Formula"
    Set cellule = LG_FeuilleInitiale.Cells(ligne, colonne)
End Function

Sub Figure()
    If LG_TracerDansNouveauClasseur Or (Workbooks.Count = 0) Then CreeerNouveauClasseur
    If (Workbooks.Count = 1) And (Workbooks(1).Name = "Classeur de macros personnelles") Then CreeerNouveauClasseur
    Set LG_FeuilleInitiale = ActiveWorkbook.ActiveSheet ' Erreur si pas de classeur ouvert
    VE
    InitFonctions
    LG_NbTotalImagesFilm = 0
    Application.ScreenUpdating = LG_MiseAuPoint
    LG_ModeDemo = False
    Graphique
    If LG_NbTotalImagesFilm = 0 Then GrouperGraphique
End Sub

Sub FigureVide()
    If LG_TracerDansNouveauClasseur Or (Workbooks.Count = 0) Then CreeerNouveauClasseur
    If (Workbooks.Count = 1) And (Workbooks(1).Name = "Classeur de macros personnelles") Then CreeerNouveauClasseur
    Set LG_FeuilleInitiale = ActiveWorkbook.ActiveSheet ' Erreur si pas de classeur ouvert
    VE
    InitFonctions
    LG_NbTotalImagesFilm = 0
    Application.ScreenUpdating = LG_MiseAuPoint
    LG_ModeDemo = False
    
    If LG_NbTotalImagesFilm = 0 Then GrouperGraphique
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Word 2007+2010+2011 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Sub InstallerBarreProgiciels()
    EnlevererBarreProgiciels
    On Error GoTo Fin
    CommandBars.Add(Name:="Progiciels").Visible = True
    CommandBars("Progiciels").Controls.Add Type:=msoControlButton, Before:=1
    CommandBars("Progiciels").Controls(1).FaceId = 67
    CommandBars("Progiciels").Controls(1).Caption = "Effacer les graphiques"
    CommandBars("Progiciels").Controls(1).OnAction = "LangageGraphique.VE"
    CommandBars("Progiciels").Controls.Add Type:=msoControlButton, Before:=1
    CommandBars("Progiciels").Controls(1).FaceId = 274
    If LG_MachineCourante = "Mac" Then LG_chaineAdaptee = "Ajouter une tiquette" Else LG_chaineAdaptee = "Ajouter une tiquette"
    CommandBars("Progiciels").Controls(1).Caption = LG_chaineAdaptee
    CommandBars("Progiciels").Controls(1).OnAction = "LangageGraphique.Etiquette"
    CommandBars("Progiciels").Controls.Add Type:=msoControlButton, Before:=1
    CommandBars("Progiciels").Controls(1).FaceId = 59
    CommandBars("Progiciels").Controls(1).Caption = "Tracer la figure"
    CommandBars("Progiciels").Controls(1).OnAction = "LangageGraphique.Figure"
    CommandBars("Progiciels").Controls.Add Type:=msoControlButton, Id:=1695, Before:=1 'Editeur VB
    CommandBars("Progiciels").Controls.Add Type:=msoControlButton, Id:=546, Before:=1  'Insertion objet (dont Equation)
    CommandBars("Progiciels").Controls(1).FaceId = 477
    CommandBars("Progiciels").Controls(1).Style = msoButtonIcon
Fin: On Error GoTo 0
End Sub

Sub EnlevererBarreProgiciels()
    On Error Resume Next
    CommandBars("Progiciels").Delete
    On Error GoTo 0
End Sub

Sub CreerBoutons()
    x = 10: y = 100: dy = 10: b = 90: h = 20
    CreerBouton "Tracer", "Figure", x, y, b, h
    CreerBouton "Etiquette", "Etiquette", x, y + (dy + h), b, h
    CreerBouton "Effacer", "VE", x, y + 2 * (dy + h), b, h
End Sub

Sub CreerBouton(NomBouton, NomMacro, x, y, b, h)
    ActiveSheet.Buttons.Add(x, y, b, h).Select
    Selection.OnAction = NomMacro
    Selection.Characters.Text = NomBouton
    With Selection.Characters(Start:=1, Length:=9).Font
        .Name = "Lucida Grande"
        .FontStyle = "Normal"
        .Size = 12
        .StrikeThrough = False
        .Superscript = False
        .Subscript = False
        .OutlineFont = False
        .Shadow = False
        .Underline = xlUnderlineStyleNone
        .ColorIndex = xlAutomatic
    End With
    Range("A1").Select
End Sub

Sub BugVieuxExcel()
    c = 30
    For nbfois = 1 To 10 Step 1
        Av c: Dr 90: Av c: Dr 90: Av c: Dr 90: Av c: Dr 90
        Avance c / 2
        Dr 45
        c = c * Sqr(2) / 2
    Next nbfois
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DEMO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Function BinMem(x)
    BinMem = BinaireEnMemoire(x)
End Function

Function BinPer(a, b)
    BinPer = BinairePeriodique(a, b)
End Function

Function BinaireEnMemoire(ByVal x)
' Entre : un nombre en virgule flottante
' Sortie : une chane dcrivant sa reprsentaqtion en mmoire (mantisse en binaire, exposant en dcimal)
    nbChiffres = 53 ' mantisse de 53 chiffres binaires dans Excel
    If x = 0 Then
        chaine = "+0."
        For k = 1 To nbChiffres - 1
            chaine = chaine + "0"
        Next k
        BinaireEnMemoire = chaine + "2^0"
        Exit Function
    End If
    If x > 0 Then chaine = "+" Else chaine = "-"
    x = Abs(x)
    n = 0 ' n varie entre -1022 et 1023
    While x < 1
        x = 2 * x
        n = n - 1
    Wend
    While 2 <= x
        x = x / 2
        n = n + 1
    Wend
    For k = 1 To nbChiffres
        d = Int(x)
        chaine = chaine + CStr(d)
        x = 2 * (x - d)
    Next k
    BinaireEnMemoire = Mid(chaine, 1, 2) + "." + Mid(chaine, 3, Len(chaine) - 2) + "2^" + CStr(n)
    ' If x <> 0 Then MsgBox "Bizarre" Else MsgBox "Ok"
End Function

Function BinairePeriodique(ByVal p, ByVal q)
' Entres : deux nombres (des petits entiers), soit le numrateur et le dnominateur de la fraction
' Sortie : une chane reprsentant le nombre binaire priodique associ
    Dim F, nbDecTest, r, u, longDebut, k, j As Integer
    Dim restes() As Integer
    nbDecTest = 200: chaine = ""
    ReDim restes(nbDecTest + 1)
    r = p Mod q  ' Vrifier : Mod ne fonctionne qu'avec de petits entiers ?
    p = Int(p / q)
    While p > 0
        u = p Mod 2
        p = Int(p / 2)
        chaine = CStr(u) + chaine
    Wend
    If chaine = "" Then chaine = "0"
    chaine = chaine + "."
    longDebut = Len(chaine)
    F = 0
    restes(1) = r
    For k = 1 To nbDecTest
        p = Int(2 * r / q)
        chaine = chaine + CStr(p)
        r = 2 * r - p * q
        restes(k + 1) = r
        For j = 1 To k
            If restes(j) = r Then
                F = j
                j = nbDecTest
                k = nbDecTest
            End If
        Next j
    Next k
    If F > 0 Then
        chaine = Mid(chaine, 1, longDebut + F - 1) + "[" + Mid(chaine, longDebut + F, Len(chaine) - longDebut - F + 1) + "]"
    Else
        chaine = chaine + "..."
    End If
    BinairePeriodique = " " + chaine
End Function

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DEMO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Sub Demo()
    Dim i As Integer
    LG_ModeDemo = True
        nb = InputBox("Nombre de triangles:" + Chr(13) + " (Entre 6 et 28)", "Spirale de Pythagore")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 1, 28)
        SpiralePythagore 70, nb
    If ArretP Then Exit Sub
        nb = InputBox("Nombre de perles:" + Chr(13) + " (Entre 2 et 100)", "Colliers")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 2, 150)
        Collier 250, nb
    If ArretP Then Exit Sub
        nb = InputBox("Nombre de demi-cercles:" + Chr(13) + " (Entre 1 et 50)", _
            "Approcher segment par demi-cercles")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 1, 100)
        Approx 275, nb
    If ArretP Then Exit Sub
        nb = InputBox("Nombre max de niveaux:" + Chr(13) + " (Entre 0 et 5)", "Flocon de Koch")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 0, 5)
        FigureFlocon nb
    If ArretP Then Exit Sub
        nb = InputBox("Nombre max de niveaux:" + Chr(13) + " (Entre 0 et 5)", "Triangle de Sierpinski")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 0, 5)
        For i = 1 To nb + 1
            VE
            LC
            FPos -300, -200
            BC
            Droite 30
            SierpinskiRemplis 600, i
            GrouperGraphique
            Application.ScreenUpdating = True
            If i <= nb Then Rep = MsgBox("Niveau suivant?", vbOKOnly, "Niveau " + CStr(i - 1))
        Next i
    If ArretP Then Exit Sub
        If LG_MachineCourante = "Mac" Then LG_chaineAdaptee = "Approcher sinus par des polynmes" Else LG_chaineAdaptee = "Approcher sinus par des polynmes"
        nb = InputBox("Nombre d'approximations:" + Chr(13) + " (Entre 0 et 4)" + Chr(13), LG_chaineAdaptee)
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 0, 4)
        Fonctions (nb)
    If ArretP Then Exit Sub
        nb = InputBox("Nombre d'images:" + Chr(13) + " (Entre 2 et 30)", "Pentagone (film)")
        If Not IsNumeric(nb) Then Exit Sub
        nb = recadrer(CInt(nb), 2, 30)
        'FaireFilm nb, -100, -100, 100, 100, 255, 255, 0
        r = 200: n = 5: p = 2: alpha = 18: nbImages = nb
        FaireFilm nbImages, -(r + 10), -(r + 10), (r + 10), (r + 10), 255, 255, 0
End Sub

Function ArretP()
    GrouperGraphique
    Application.ScreenUpdating = True
    Rep = MsgBox("On continue?", vbYesNo, "Message")
    ArretP = (Rep = vbNo)
    If Not ArretP Then
        VE 'Init
    End If
End Function

Sub DemoNo(n)
    LG_ModeDemo = True
    Select Case n
        Case 1
            nb = InputBox("Nombre de triangles:" + Chr(13) + " (Entre 6 et 28)", "Spirale de Pythagore")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 1, 28)
            SpiralePythagore 70, nb
        Case 2
            nb = InputBox("Nombre de perles:" + Chr(13) + " (Entre 2 et 100)", "Colliers")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 2, 150)
            Collier 250, nb
        Case 3
            nb = InputBox("Nombre de demi-cercles:" + Chr(13) + " (Entre 1 et 50)", _
            "Approcher segment par demi-cercles")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 1, 100)
            Approx 275, nb
        Case 4
            nb = InputBox("Nombre de niveaux:" + Chr(13) + " (Entre 0 et 5)", "Flocon de Koch")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 0, 5)
            FigureFlocon nb
        Case 5
            nb = InputBox("Nombre de niveaux:" + Chr(13) + " (Entre 0 et 5)", "Triangle de Sierpinski")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 0, 5)
            LC
            FPos -300, -200
            BC
            Droite 30
            SierpinskiRemplis 600, nb + 1
        Case 6
            If LG_MachineCourante = "Mac" Then LG_chaineAdaptee = "Approcher sinus par des polynmes" Else LG_chaineAdaptee = "Approcher sinus par des polynmes"
            nb = InputBox("Nombre d'approximations:" + Chr(13) + " (Entre 0 et 4)" + Chr(13), LG_chaineAdaptee)
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 0, 4)
            Fonctions (nb)
        Case 7
            nb = InputBox("Nombre d'images:" + Chr(13) + " (Entre 2 et 30)", "Pentagone (film)")
            If Not IsNumeric(nb) Then Exit Sub
            nb = recadrer(CInt(nb), 2, 30)
            'FaireFilm nb, -100, -100, 100, 100, 255, 255, 0
            r = 200: n = 5: p = 2: alpha = 18: nbImages = nb
            FaireFilm nbImages, -(r + 10), -(r + 10), (r + 10), (r + 10), 255, 255, 0
        Case Else
    End Select
End Sub

Function recadrer(x, a, b)
    recadrer = x
    If x < a Then recadrer = a
    If x > b Then recadrer = b
End Function

Sub SpiralePythagore(cote, nombre)
    Dim x As Double, y As Double, Angle As Double, i As Integer
    x = cote
    y = 0
    Angle = 0
    For i = 1 To nombre
        CC 256 * Rnd(), 256 * Rnd(), 256 * Rnd()
        CR 256 * Rnd(), 256 * Rnd(), 256 * Rnd()
        DebutRemplir
        FPos x, y
        Dr -Angle
        Av cote
        x = LG_TortueX
        y = LG_TortueY
        FPos 0, 0
        FinRemplir
        Dessous
        Angle = Atn(1 / Sqr(i)) * 180 / 3.14159265
    Next i
End Sub


Sub Collier(r, n)
    'Cercle 0, 0, R
    R1 = r * Sin(3.14159265 / n) / (1 + Sin(3.14159265 / n))
    For i = 0 To n - 1
        CR Hasard(0, 255), Hasard(0, 255), Hasard(0, 255)
        Disque (r - R1) * Cos(i * 2 * pi / n), (r - R1) * Sin(i * 2 * 3.14159265 / n), R1
    Next i
    'Cercle 0, 0, R - 2 * R1
End Sub

Sub Approx(xmax, n)
    Dim i As Integer
    Segment -xmax, 0, xmax, 0
    r = xmax / (1 * n)
    x0 = -xmax + r
    For i = 1 To n
        If (i Mod 2) = 1 Then Arc x0, 0, r, 0, 180 Else Arc x0, 0, r, 180, 0
        x0 = x0 + 2 * r
    Next i
End Sub

Sub ExApprox(xmax, n)
    Dim i As Integer
    Segment 0, 0, xmax, 0
    r = xmax / (2 * n)
    x0 = r
    For i = 1 To n
        If (i Mod 2) = 1 Then Arc x0, 0, r, 0, 180 Else Arc x0, 0, r, 180, 0
        x0 = x0 + 2 * r
    Next i
End Sub

Sub FigureFlocon(niv)
    Dim i As Integer
    For i = 0 To niv
        Application.ScreenUpdating = False ' Mettre en commentaire si on veut voir tracer pas  pas
        VE
        LC
        FPos -300, -200
        BC
        CR 255 * Rnd(), 255 * Rnd(), 255 * Rnd()
        DebutRemplir ' INVESTIGUER: remplir acclre les tracs
        DessinFlocon 600, i
        FinRemplir
        Application.ScreenUpdating = True
        GrouperGraphique
        If i < niv Then Rep = MsgBox("Flocon suivant?", vbOKOnly, "Niveau " + CStr(i))
    Next i
End Sub

Sub DessinFlocon(taille, n)
    Dim i As Integer
    Dr 30
    For i = 1 To 3
        Flocon taille, n
        Dr 120
    Next i
End Sub

Sub Flocon(taille, NbNiveaux)
    If NbNiveaux = 0 Then
        Av taille
        Exit Sub
    End If
    Flocon taille / 3, NbNiveaux - 1
    Dr -60
    Flocon taille / 3, NbNiveaux - 1
    Dr 120
    Flocon taille / 3, NbNiveaux - 1
    Dr -60
    Flocon taille / 3, NbNiveaux - 1
End Sub

Sub SierpinskiRemplis(d, E)
    Dim i As Integer
    If E = 0 Then Exit Sub
    If E = 1 Then
        BC
        DebutRemplir
        CR 255 * Rnd(), 255 * Rnd(), 255 * Rnd()
    End If
    For i = 1 To 3
        SierpinskiRemplis (d / 2), E - 1
        Av d
        Dr 120
    Next i
    If E = 1 Then
        FinRemplir
        LC
    End If
End Sub

Sub Fonctions(n)
    RegionFonctions -pi, pi, -2, 2
    FenetreFonctions -200, 200, -150, 150
    TracerAxes
    PasFonctions 5
    TC 2
    CC 0, 0, 0
    TracerFonction 1
    For k = 2 To n + 1
        Select Case k
            Case 2
                CC 0, 0, 255
            Case 3
                CC 0, 255, 0
            Case 4
                CC 0, 255, 255
            Case 5
                CC 255, 0, 0
            Case Else
        End Select
        TracerFonction k
    Next k
End Sub


Sub TracerFonctionAuxDemo(NumeroFonction, Pas, Lier)
    Dim yE0 As Variant, xE As Double, x As Double, y As Variant, yE As Double
    yE0 = "ND"
    For xE = LG_FenetreXmin To LG_FenetreXmax Step Pas
        x = LG_FonctionsMX * xE + LG_FonctionsBX
        y = Fdemo(NumeroFonction, x)
        If y = "ND" Then  ' ND = Non Dfini
            yE0 = "ND"
        Else
            If y < LG_FonctionsYmin Then y = LG_FonctionsYmin
            If y > LG_FonctionsYmax Then y = LG_FonctionsYmax
            yE = LG_FonctionsMYE * y + LG_FonctionsBYE
            If Not Lier Then
                Segment xE, yE, xE, yE 'Disque Xecran, Yecran, Taille
            Else
                Select Case yE0
                    Case "ND"
                        Segment xE, yE, xE, yE
                    Case Else
                        Segment xE - Pas, yE0, xE, yE
                End Select
            End If
            yE0 = yE
        End If
    Next xE
    CadreFonctions
End Sub

Function Fdemo(n, x)
    Fdemo = "ND"
    On Error GoTo Erreur
    Select Case n
        Case 1
            Fdemo = Sin(x)
        Case 2
            Fdemo = x
        Case 3
            Fdemo = x - x * x * x / 6
        Case 4
            Fdemo = x - x * x * x / 6 + x * x * x * x * x / 120
        Case 5
            Fdemo = x - (x ^ 3) / fac(3) + (x ^ 5) / fac(5) - (x ^ 7) / fac(7)
        Case 6
            
        Case 7
            
        Case 8
            
        Case 9
            
        Case 10
            
        Case Else
            
    End Select
Erreur:
End Function

Function fac(n)
    Dim k As Integer, p As Integer
    p = 1
    For k = 2 To n
        p = p * k
    Next k
    fac = p
End Function

Sub TracerImageDemo(noImage)
    'Collier 80, noImage + 3
    r = 200: n = 5: p = 2: alpha = 18 * pi / 180: nbImages = LG_NbTotalImagesFilm
    PolyEtoile r, n, p, alpha, (noImage - 1) / (nbImages - 1)
End Sub

Sub TracerImageDemoAlt(n) ' n entre 1 et 6
    LC
    FPos -95, -85
    BC
    Droite 30
    SierpinskiRemplis 190, n
End Sub

Sub PolyEtoile(r, n, p, alpha, c)
    p = p Mod n
    If p = 0 Then Exit Sub
    nbetapes = Int(c * ppcm(n, p) / p)
    For k = 0 To nbetapes - 1
        Segment r * Cos(alpha + k * p * 2 * pi / n), r * Sin(alpha + k * p * 2 * pi / n), r * Cos(alpha + (k + 1) * p * 2 * pi / n), r * Sin(alpha + (k + 1) * p * 2 * pi / n)
    Next k
    reste = c * ppcm(n, p) / p - nbetapes
    Segment r * Cos(alpha + nbetapes * p * 2 * pi / n), r * Sin(alpha + nbetapes * p * 2 * pi / n), _
            r * Cos(alpha + nbetapes * p * 2 * pi / n) + reste * r * (Cos(alpha + (nbetapes + 1) * p * 2 * pi / n) - Cos(alpha + nbetapes * p * 2 * pi / n)), _
            r * Sin(alpha + nbetapes * p * 2 * pi / n) + reste * r * (Sin(alpha + (nbetapes + 1) * p * 2 * pi / n) - Sin(alpha + nbetapes * p * 2 * pi / n))
End Sub

Function ppcm(ByVal a, ByVal b)
    aa = a: bb = b
    While aa <> bb
        If aa < bb Then aa = aa + a
        If aa > bb Then bb = bb + b
    Wend
    ppcm = aa
End Function


